#ifndef __DYNDNSUPDATEREPLICANT_H__
#define __DYNDNSUPDATEREPLICANT_H__

#include <View.h>
#include <time.h>

#define		MAX_BBMP_PENDING	4

class BBitmap;
class DynDnsUpdate;
class DynDnsSettingsWin;
class BPopUpMenu;

class _EXPORT DynDnsUpdateReplicant : public BView
{
public:
	DynDnsUpdateReplicant();
	DynDnsUpdateReplicant(BMessage *message);
	virtual	~DynDnsUpdateReplicant();

	// for archiving view in deskbar
	static	DynDnsUpdateReplicant	*Instantiate(BMessage *data);
	virtual	status_t 				Archive(BMessage *data, bool deep = true) const;

	// attache and dettached from window (=deskbar)
	virtual	void		AttachedToWindow();
	virtual	void		DetachedFromWindow();
	
protected:
	DynDnsSettingsWin	*_settingWin;
	BPopUpMenu			*_optionMenu;
	DynDnsUpdate		*_dyndns;
	time_t				_lastPulse;
	int32				_delay;
	int8				_cmpt;
	
	// bitmap
	// Normal/Pending Animation/Error
	BBitmap			*_displayedBitmap;
	BBitmap			*_normalBitmap;
	BBitmap			*_pendingBitmap[MAX_BBMP_PENDING];
	BBitmap			*_errorBitmap;


	virtual	void		Draw(BRect updateRect);
	virtual	void		MouseDown(BPoint point);
	virtual	void		Pulse();
			BBitmap 	*GetBitmap(const char *name,int32 type);
			void		BuildMenu();
};

#endif