/************************/
/* classe MTab speciale */
/************************/
#include "MTabView.h"

#include <stdio.h>

/**** constructeur ****/
MTabView::MTabView(BRect frame,const char *name)
: BTabView(frame,name,B_WIDTH_FROM_LABEL)
{
}

/**** destructeur ****/
MTabView::~MTabView()
{
}

/**** drawing tabs ****/
BRect MTabView::DrawTabs()
{
	BRect	tabFrame;
	int32	nbTabs;
	
	nbTabs = CountTabs();
	for(int i=0;i<nbTabs;i++)
	{
		// get the rect of the tab i
		tabFrame = TabFrame(i);
		
		if(i==Selection())
		{
			SetHighColor(tint_color(ui_color(B_PANEL_BACKGROUND_COLOR),B_LIGHTEN_MAX_TINT));
			StrokeLine(BPoint(tabFrame.left,1),BPoint(tabFrame.left,tabFrame.bottom));
			StrokeLine(BPoint(tabFrame.left+1,0),BPoint(tabFrame.right-1,0));
		}
		else
		{
			SetHighColor(tint_color(ui_color(B_PANEL_BACKGROUND_COLOR),B_LIGHTEN_1_TINT));

		}		
		SetHighColor(tint_color(ui_color(B_PANEL_BACKGROUND_COLOR),B_DARKEN_4_TINT));
		StrokeLine(BPoint(tabFrame.right,1),BPoint(tabFrame.right,tabFrame.bottom));

		// fill the rect
		SetHighColor(192,192,192);
		tabFrame.InsetBy(1,1);
		if(i==Selection())
			SetHighColor(ui_color(B_PANEL_BACKGROUND_COLOR));		
		FillRect(tabFrame);
		
		// draw label of tab
		DrawLabel(i);
		
		// draw the rect make with point
		DrawRectOfPoint(BRect(tabFrame.left,tabFrame.top+1,tabFrame.left+4,tabFrame.bottom-1));
	}
	
	// return tab frame
	return TabFrame(Selection());
}

/*** give size of tabs ****/
BRect MTabView::TabFrame(int32 tab_index) const
{
	BRect	bounds;
	BRect	tabSize;
	float	width;
	
	// calcul width function of total tabs
	bounds = Bounds();
	width = bounds.right / CountTabs();
	
	// fix size of tab (tab_index)
	tabSize.left = width * tab_index;
	tabSize.right = tabSize.left + width;
	tabSize.top = 0;
	tabSize.bottom = TabHeight();
	
	// return size
	return tabSize;
}

/**** draw container view ****/
void MTabView::DrawBox(BRect selTabRect)
{
	BRect	bounds;
	BRect	selectedRect;

	bounds = Bounds();
	selectedRect = TabFrame(Selection());
	//255,255,255
	SetHighColor(tint_color(ui_color(B_PANEL_BACKGROUND_COLOR),B_LIGHTEN_MAX_TINT));
	StrokeLine(BPoint(0,selTabRect.bottom+1),BPoint(0,bounds.bottom-1));
	StrokeLine(BPoint(1,selTabRect.bottom+1),BPoint(bounds.right-1,selTabRect.bottom+1));
	
	// 96,96,96
	SetHighColor(tint_color(ui_color(B_PANEL_BACKGROUND_COLOR),B_DARKEN_4_TINT));
	StrokeLine(BPoint(bounds.right,selTabRect.bottom+1),BPoint(bounds.right,bounds.bottom));	
	StrokeLine(BPoint(1,bounds.bottom),BPoint(bounds.right,bounds.bottom));

	// 216,216,216
	SetHighColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	StrokeLine(BPoint(selectedRect.left+1,selTabRect.bottom+1),BPoint(selectedRect.right-1,selTabRect.bottom+1));		
}

/**** draw the label of the tab ****/
void MTabView::DrawLabel(int32 tab_index)
{
	BTab	*tab = NULL;
	
	tab = TabAt(tab_index);
	if(tab!=NULL)
	{
		BFont	viewFont;
		BRect	tabFrame;
		float	startHString;
		float	startWString;
		
		GetFont(&viewFont);
		startHString = (TabHeight() - viewFont.Size()) / 2 + viewFont.Size() -1;
		tabFrame = TabFrame(tab_index);
		SetHighColor(tint_color(ui_color(B_PANEL_BACKGROUND_COLOR),B_DARKEN_MAX_TINT));
		startWString = tabFrame.left + 6 + ((tabFrame.Width() - 6 - StringWidth(tab->Label())) / 2);
		DrawString(tab->Label(),BPoint(startWString,startHString));
	}
}

/**** dessin des petits points ****/
void MTabView::DrawRectOfPoint(BRect frame)
{	
	SetHighColor(255,255,255);
	StrokeLine(BPoint(frame.left+1,frame.top),BPoint(frame.left+1,frame.bottom-2),B_MIXED_COLORS);
	SetHighColor(100,100,100);
	StrokeLine(BPoint(frame.left+2,frame.top+1),BPoint(frame.left+2,frame.bottom-1),B_MIXED_COLORS);
	SetHighColor(255,255,255);
	StrokeLine(BPoint(frame.left+3,frame.top),BPoint(frame.left+3,frame.bottom-2),B_MIXED_COLORS);
	SetHighColor(100,100,100);
	StrokeLine(BPoint(frame.left+4,frame.top+1),BPoint(frame.left+4,frame.bottom-1),B_MIXED_COLORS);
}
