#include "MUrlView.h"
#include <Roster.h>

#include <iostream.h>

/**** constructeur ****/
MUrlView::MUrlView(BRect frame, const char *label, const char *url,url_type type)
: BView(frame,label,B_FOLLOW_LEFT_RIGHT,B_WILL_DRAW | B_FRAME_EVENTS)
{
	_label = label;
	_url = url;
	_entered = false;
	_type = type;

	// si c'est un E-Mail on doit ajouter mailto:
	if(_type == MAIL_LINK && _url.FindFirst("mailto:")==B_ERROR)
		_url.Prepend("mailto:");

	SetViewColor(255,255,255);
}

/**** destructeur ****/
MUrlView::~MUrlView()
{
}

/**** gestion des messages ****/
void MUrlView::MessageReceived(BMessage *message)
{
	switch(message->what)
	{
	default:
		BView::MessageReceived(message);	
	}
}

/*** activer l'ouverture du navigateur ****/
void MUrlView::MouseDown(BPoint point)
{
	char	*url;

	url = _url.LockBuffer(0);
	switch(_type)
	{
	case WWW_LINK:
		be_roster->Launch("text/html", 1, &url);
		break;
	case MAIL_LINK:
		be_roster->Launch("text/x-email", 1, &url);
		break;
	default:
		; // on fait rien
	}
	// on libere le buffer
	_url.UnlockBuffer();
}

/*** on bouge la souris ****/
void MUrlView::MouseMoved(BPoint point, uint32 transit,const BMessage *message)
{
	switch(transit)
	{
		case B_ENTERED_VIEW:
			_entered = true;
			Invalidate();
			break;
		case B_EXITED_VIEW:
			_entered = false;
			Invalidate();
			break;
		case B_INSIDE_VIEW:
			if(!_entered)
				Invalidate();
	}
}

/**** dessin ****/
void MUrlView::Draw(BRect updateRect)
{
	BRect	bounds = Bounds();

	SetHighColor(ViewColor());
	FillRect(bounds);

	SetLowColor(ViewColor());
	SetHighColor(50,50,170);
	if(_entered)
		SetHighColor(200,0,255);	

	DrawString(_label.String(),BPoint(0,10));
}