#ifndef __DYNDNSUPDATE_H__
#define __DYNDNSUPDATE_H__

#include <Looper.h>

// BeOS network class
#include <NetAddress.h>
#include <NetEndpoint.h>
#include <String.h>

// Messages & constants
#define		DYNDNS_IPCHECK_MSG		'DDic'
#define		DYNDNS_IPUPDATE_MSG		'DDiu'
#define		DEFAULT_LOG_LENGTH		4096

// just here for the moment
#define CLIENT				"BeDynDnsUpdater"
#define CLIENT_VERSION		"v0.2a"
#define CLIENT_DEVELOPPER	"ckj.beos@wanadoo.fr"

class DynDnsUpdate : public BLooper
{
public:
	DynDnsUpdate();
	virtual	~DynDnsUpdate();
	
	// virtual functions from BLooper
	virtual	void		MessageReceived(BMessage *message);

	// acces to data
	inline	bool		IsPending()			{ return _pending; }
	inline	status_t	CheckIpStatus()		{ return _checkIpStatus; }
	inline	status_t	UpdateIpStatus()	{ return _updateStatus; }
	inline	const char	*Log()				{ return _log.String(); }

protected:
	// network
	BNetAddress		_server;
	BNetEndpoint	_member;
	
	// to know if send/recieve
	// and result
	bool			_pending;
	status_t		_updateStatus;
	status_t		_checkIpStatus;
	BString			_log;

	status_t	Update();
	status_t	CheckIp();
	BString		EncodeBase64(const char *buffer);
	void		Log(const char *trace);
	void		CheckLog();
};

#endif