/**************/
/* About View */
/**************/
#include "AboutView.h"
#include "CPreferences.h"
#include "MUrlView.h"
#include "DynDnsUpdate.h"

#include <Roster.h>
#include <Bitmap.h>
#include <AppFileInfo.h>

/**** constructor ****/
AboutView::AboutView(BRect frame)
: BView(frame,"About",B_FOLLOW_ALL_SIDES, B_WILL_DRAW)
{
	CPreferences	prefs;
	BFile			file;
	BAppFileInfo	fileinfo;
	
	// fix view color (standard color)
	SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));

	// load prefs
	prefs.Load();
	
	// get the icon of application
	_iconApp = new BBitmap(BRect(0,0,31,31),B_CMAP8);
	file.SetTo(prefs._applicationPath.String(),B_READ_ONLY);
	if(file.InitCheck()==B_OK)
	{
		fileinfo.SetTo(&file);
		fileinfo.GetIcon(_iconApp, B_LARGE_ICON);
	}
	
	// url view for link to my website
	// and E-Mail
	_www = new MUrlView(BRect(65,72,250,87),"http://perso.wanadoo.fr/cvincent","http://perso.wanadoo.fr/cvincent",WWW_LINK);
	_www->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	_mail = new MUrlView(BRect(80,100,210,112),"vincent-cedric@wanadoo.fr","vincent-cedric@wanadoo.fr",MAIL_LINK);
	_mail->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));

	AddChild(_www);
	AddChild(_mail);
}

/**** destructor ****/
AboutView::~AboutView()
{
	delete _iconApp;
}

/**** manage messaging ****/	
void AboutView::MessageReceived(BMessage *message)
{
}

/**** drawing the view ****/
void AboutView::Draw(BRect updateRect)
{
	BFont		fontView;
	BRect		bounds;

	// rect
	bounds = Bounds();
	SetHighColor(tint_color(ui_color(B_PANEL_BACKGROUND_COLOR),B_LIGHTEN_1_TINT));
	FillRect(BRect(0,0,50,bounds.bottom));

	// draw Bitmap and title
	SetDrawingMode(B_OP_OVER);
	DrawBitmap(_iconApp,BPoint(38,13));	
	SetDrawingMode(B_OP_COPY);
	
	// mail info web site
	SetHighColor(0,0,0);
	SetLowColor(ViewColor());
	SetFontSize(20.0);
	fontView.SetShear(105.0);
	SetFont(&fontView,B_FONT_SHEAR);
	DrawString("DynDnsUpdate", BPoint(75,30));
	
	SetFontSize(10.0);
	fontView.SetShear(90.0);
	SetFont(&fontView,B_FONT_SHEAR);
	DrawString("for BeOS", BPoint(110,45));
	DrawString(CLIENT_VERSION,BPoint(155,45));
	DrawString("My web site", BPoint(115,69));
	DrawString("My E-Mail", BPoint(122,97));

	// info bug etc...
	DrawString("Contact me by mail for bug or idea.", BPoint(65,127));
	DrawString("You must contact me before modify", BPoint(65,137));
	DrawString("this program, thanks.",BPoint(95,147));
	
	// normal drawing for other control
	BView::Draw(updateRect);
}