/**************/
/* Other View */
/**************/

#include "OtherView.h"
#include "CPreferences.h"

#include <CheckBox.h>
#include <MenuField.h>
#include <TextControl.h>
#include <PopUpMenu.h>
#include <MenuItem.h>

#include <stdio.h>

/**** constructor ****/
OtherView::OtherView(BRect frame)
: BView(frame,"Other",B_FOLLOW_ALL_SIDES, B_WILL_DRAW)
{
	CPreferences	prefs;

	// load prefs
	prefs.Load();

	// fix view color (standard color)
	SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));

	// options
	_wildcard = new BCheckBox(BRect(10,20,200,30),"wildcard-check","Wildcard",NULL);
	_backmx = new BCheckBox(BRect(10,40,200,50),"backmx-check","Back mx",NULL);
	_offline = new BCheckBox(BRect(10,60,200,70),"offline-check","Offline",NULL);

	// mx option
	_mx = new BTextControl(BRect(10,85,250,95),"mx-edit","Mail Exchanger","",NULL);
	_mx->SetDivider(80);
	_mx->TextView()->DisallowChar(27);

	// system choice
	_menu = new BPopUpMenu(prefs._system.String());
	_menu->AddItem(new BMenuItem("dyndns",NULL));
	_menu->AddItem(new BMenuItem("statdns",NULL));
	_menu->AddItem(new BMenuItem("custom",NULL));
	_system = new BMenuField(BRect(10,110,180,130),"system-menufield","System",_menu,true);
	_system->SetDivider(82);
	// fix values
	_mx->SetText(prefs._mx.String());
	
	// add
	AddChild(_wildcard);
	AddChild(_backmx);
	AddChild(_offline);
	AddChild(_mx);
	AddChild(_system);
}

/**** destructor ****/
OtherView::~OtherView()
{
}

/**** call to save settings into preference file ****/
void OtherView::SaveSettings()
{
	CPreferences	prefs;

	// load prefs
	prefs.Load();

	// change datas values	
	prefs._system = _system->MenuItem()->Label();
	prefs._wildcard = _wildcard->Value();
	prefs._backmx = _backmx->Value();
	prefs._offline = _offline->Value();
	prefs._mx = _mx->Text();

	// save
	prefs.Save();
}
