/***************/
/* Server View */
/***************/

#include "ServerView.h"
#include "CPreferences.h"
#include <TextControl.h>
#include <stdio.h>

/**** constructor ****/
ServerView::ServerView(BRect frame)
: BView(frame,"Server",B_FOLLOW_ALL_SIDES, B_WILL_DRAW)
{
	CPreferences	prefs;
	BString			delay;

	// load prefs
	prefs.Load();

	// fix view color (standard color)
	SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));

	// create edit control
	_serverDns = new BTextControl(BRect(10,20,250,30),"server-Dns-edit","Server DynDns","",NULL);
	_serverIpCheck = new BTextControl(BRect(10,45,250,55),"server-ip-edit","Server Ip Check","",NULL);
	_delay = new BTextControl(BRect(10,70,180,80),"delay","Delay for ipCheck (minutes)","",NULL);

	// fix size of edit
	_serverDns->SetDivider(80);
	_serverIpCheck->SetDivider(80);
	_delay->SetDivider(135);

	// disable key ESC
	_serverDns->TextView()->DisallowChar(27);
	_serverIpCheck->TextView()->DisallowChar(27);
	_delay->TextView()->DisallowChar(27);
	
	// fix values
	_serverDns->SetText(prefs._dyndnsServer.String());
	_serverIpCheck->SetText(prefs._checkIpServer.String());
	// delay
	delay = "";
	delay << prefs._delay/60;
	_delay->SetText(delay.String());

	// disable edit
	_serverDns->SetEnabled(false);
	_serverIpCheck->SetEnabled(false);

	AddChild(_serverDns);
	AddChild(_serverIpCheck);
	AddChild(_delay);
}

/**** destructor ****/
ServerView::~ServerView()
{
}

/**** call to save settings into preference file ****/
void ServerView::SaveSettings()
{
	CPreferences	prefs;
	int32			delay;

	// load prefs
	prefs.Load();

	// change datas values	
	prefs._dyndnsServer = _serverDns->Text();
	prefs._checkIpServer = _serverIpCheck->Text();
	sscanf(_delay->Text(),"%ld",&delay);
	// we must have a minimum
	if(delay<5)
		delay = 5;
	prefs._delay = delay * 60;

	// save
	prefs.Save();
}
