/*************/
/* User View */
/*************/

#include "UserView.h"
#include "CPreferences.h"
#include <TextControl.h>

/**** constructor ****/
UserView::UserView(BRect frame)
: BView(frame,"User",B_FOLLOW_ALL_SIDES, B_WILL_DRAW)
{
	CPreferences	prefs;

	// load prefs
	prefs.Load();

	// fix view color (standard color)
	SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));

	// create edit control
	_user = new BTextControl(BRect(10,20,250,30),"user-edit","User","",NULL);
	_password = new BTextControl(BRect(10,45,250,55),"password-edit","Password","",NULL);
	_host = new BTextControl(BRect(10,70,250,80),"host-edit","Host","",NULL);
	_ip = new BTextControl(BRect(10,95,250,105),"ip","Ip Address","",NULL);
	
	// fix size of edit
	_user->SetDivider(55);
	_password->SetDivider(55);
	_host->SetDivider(55);
	_ip->SetDivider(55);
	
	// disable ESC char
	_user->TextView()->DisallowChar(27);
	_password->TextView()->DisallowChar(27);
	_host->TextView()->DisallowChar(27);
	_ip->TextView()->DisallowChar(27);

	// fix values
	_user->SetText(prefs._user.String());
	_password->SetText(prefs._password.String());
	_host->SetText(prefs._host.String());
	_ip->SetText(prefs._Ip.String());

	AddChild(_user);
	AddChild(_password);
	AddChild(_host);
	AddChild(_ip);
}

/**** destructor ****/
UserView::~UserView()
{
}

/**** call when tab is selected ****/
void UserView::AttachedToWindow()
{
	CPreferences	prefs;

	// load prefs
	prefs.Load();

	// call parent function
	BView::AttachedToWindow();
	
	// refresh ip display
	_ip->SetText(prefs._Ip.String());
}

/**** call to save settings into preference file ****/
void UserView::SaveSettings()
{
	CPreferences	prefs;

	// load prefs
	prefs.Load();

	// change datas values	
	prefs._user = _user->Text();
	prefs._password = _password->Text();
	prefs._host = _host->Text();
	prefs._Ip = _ip->Text();
	
	// save
	prefs.Save();
}
